# -*- coding: utf-8 -*-
"""
Created on Sun Mar  9 13:33:10 2025

@author: mstep
"""

'''Make a list-of-lists where multiples[i] holds multiples of i.'''


# Print the rows in a list of lists.
def print_2d_list(list):
    for row in list:
        print(row)
    print()
    

# Option 1: Build using two nested loops.
multiples = []
for r in range(10):
    row = []                 # Make this row's list.
    multiples.append(row)    # Add it to the list of lists.
    for c in range(10):
        row.append(r * c)
print_2d_list(multiples)

# Option 2: Build using list comprehensions.
# Step 1: Build an inner list multiples[r].
r = 3   # Just an example to get us started.
row = [r * c for c in range(10)]
print(row)
print()

# Step 2: Wrap that comprehension in another one,
# replacing r with a looping variable.
multiples = [[r * c for c in range(10)] for r in range(10)]
print('\n'.join([f'{r}' for r in multiples]) + '\n')


# Another example with lists of eEmployee objects.
# Define the Employee class.
class Employee:
    def __init__(self, name, department):
        self.name = name
        self.department = department

# Make some Employees.
employees = [
    Employee('Alice',   'Shenanigans'),
    Employee('Bob',     'Shenanigans'),
    Employee('Cindy',   'Mischief'),
    Employee('Dan',     'Mischief'),
    Employee('Eva',     'Knavery'),
    Employee('Frank',   'Mischief'),
    Employee('Gina',    'Knavery'),
    Employee('Horatio', 'Shenanigans'),
]

# Make departments{d} be a list of employees in department d.
# Step 1a: Build an inner list departments[r].
d = 'Mischief'    # "d" for "department."
department_d = [employee.name for employee in employees if employee.department == d]
print(f'Department {d}: {department_d}')

# Step 1b: Build a set of department names.
department_names = {employee.department for employee in employees}
print(f'Department Names: {department_names}')
print()

# Step 2: Wrap that comprehension in another one,
# replacing d with a looping variable.
departments = {
    d: [employee.name for employee in employees if employee.department == d]
    for d in department_names}
for key, value in departments.items():
    print(f'{key:11}: {value}')
print()

# Step 3: Replace department_names with its own comprehension.
departments = {
    d: [employee.name for employee in employees if employee.department == d]
    for d in {employee.department for employee in employees}}
for key, value in departments.items():
    print(f'{key:11}: {value}')
print()


